﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SunyruruMabangjin
{
    public class MabangjinOdd : MabangjinBase
    {

        /// <summary>
        /// 인자잇는 마방진 생성자
        /// </summary>
        /// <param name="size">마방진 크기</param>
        public MabangjinOdd(int size)
        {
            SetSize(size);
            Init();
        }

        /// <summary>
        /// 기본생성자
        /// </summary>
        public MabangjinOdd()
            : this(3)
        {
        }

        /// <summary>
        /// 소멸자
        /// </summary>
        ~MabangjinOdd()
        {
        }

        public override void Make()
        {
            int top = Size - 1;
            int x = 0;
            int y = Size / 2;
            Data[x, y] = 1;

            for (int i = 2; i <= Size * Size; i++)
            {
                int tempX = x;
                int tempY = y;

                if (x - 1 < 0)
                    x = top;
                else
                    x--;

                if (y - 1 < 0)
                    y = top;
                else
                    y--;

                if (Data[x, y] != 0)
                {
                    x = tempX + 1;
                    y = tempY;
                }

                Data[x, y] = i;
            }
        }
    }
}
